"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable */


// Pulled from https://github.com/mattzeunert/react-with-context (MIT) because it's a one-file module, doesn't build
// straight from git, and has hard deps on React instead of peer deps.

var WithContext = function (_React$Component) {
    _inherits(WithContext, _React$Component);

    function WithContext() {
        _classCallCheck(this, WithContext);

        return _possibleConstructorReturn(this, (WithContext.__proto__ || Object.getPrototypeOf(WithContext)).apply(this, arguments));
    }

    _createClass(WithContext, [{
        key: "render",
        value: function render() {
            var DynamicWithContext = function (_React$Component2) {
                _inherits(DynamicWithContext, _React$Component2);

                function DynamicWithContext() {
                    _classCallCheck(this, DynamicWithContext);

                    return _possibleConstructorReturn(this, (DynamicWithContext.__proto__ || Object.getPrototypeOf(DynamicWithContext)).apply(this, arguments));
                }

                _createClass(DynamicWithContext, [{
                    key: "getChildContext",
                    value: function getChildContext() {
                        return this.props.context;
                    }
                }, {
                    key: "render",
                    value: function render() {
                        return this.props.children;
                    }
                }]);

                return DynamicWithContext;
            }(_react2.default.Component);

            DynamicWithContext.childContextTypes = {};
            var context = this.props.context;
            for (var propertyName in context) {
                DynamicWithContext.childContextTypes[propertyName] = _react2.default.PropTypes.any;
            }

            this.validateChildren();

            return _react2.default.createElement(
                DynamicWithContext,
                { context: this.props.context },
                this.props.children
            );
        }
    }, {
        key: "validateChildren",
        value: function validateChildren() {
            if (this.props.children === undefined) {
                throw "No child components were passed into WithContext";
            }
            if (this.props.children.length > 1) {
                throw "You can only pass one child component into WithContext";
            }
        }
    }]);

    return WithContext;
}(_react2.default.Component);

exports.default = WithContext;
//# sourceMappingURL=WithContext.js.map
